//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * リーダヘッダ
 * @author Junpee
 */

#ifndef READER_H_
#define READER_H_

#include <Core/InputOutput/InputStream.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * リーダ
 *
 * データ読み込みのインターフェース
 */
class Reader{
public:
	/**
	 * 終端かどうか
	 * @return trueなら終端
	 */
	bool isEnd(){
		Assert(stream_ != NULL);
		return stream_->isEnd();
	}

	/**
	 * バイトデータの読み出し
	 * @param data 読み出し先アドレス
	 * @param size 読み出すサイズ
	 */
	void readBytes(void* data, int size){
		Assert(stream_ != NULL);
		stream_->readBytes(data, size);
	}

	/**
	 * サイズの取得
	 * @return 読み込めるバイト数
	 */
	int getSize(){
		Assert(stream_ != NULL);
		return stream_->getSize();
	}

	/**
	 * スキップ
	 *
	 * 指定されたバイト数読み飛ばします。
	 * @param size 読み飛ばすバイト数
	 */
	void skip(int size){
		Assert(stream_ != NULL);
		stream_->skip(size);
	}

	/**
	 * アライメントを取る
	 *
	 * 指定されたバイト数のアライメントまで読み込み位置をずらします。
	 * @param size アライメントをとるバイト数
	 * @return ずらしたバイト数
	 */
	int align(int size){
		Assert(stream_ != NULL);
		return stream_->align(size);
	}

	/**
	 * 読み込み位置の取得
	 * @return 読み込み位置
	 */
	int getPosition(){
		Assert(stream_ != NULL);
		return stream_->getPosition();
	}

	/**
	 * 読み込み位置の設定
	 *
	 * 指定された位置に読み込み位置を変更します。
	 * @param position 読み込み位置
	 */
	void setPosition(int position){
		Assert(stream_ != NULL);
		stream_->setPosition(position);
	}

	/**
	 * リーダの複製
	 * @return 複製されたリーダ
	 */
	virtual Reader* cloneReader() = 0;

protected:
	/**
	 * コンストラクタ
	 */
	Reader(){ stream_ = NULL; }

	/**
	 * デストラクタ
	 */
	virtual ~Reader(){
		Assert(stream_ != NULL);
		delete stream_;
		stream_ = NULL;
	}

	/// 入力ストリーム
	InputStream* stream_;

private:
	// コピーコンストラクタの隠蔽
	Reader(const Reader& copy);

	// 代入コピーの隠蔽
	void operator =(const Reader& copy);

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of READER_H_
//------------------------------------------------------------------------------
